#import "TCAppKitExtensions.h"

@implementation NSText (TCExtensions)

- (void)clear
{
    [self replaceCharactersInRange:NSMakeRange(0, [[self string] length])
                        withString:@""];
}

- (void)appendWithFormat:(NSString *)format, ...
{
    va_list	argList;
    NSString   *string;

    va_start(argList, format);
    string = [[NSString alloc] initWithFormat:format arguments:argList];
    [self replaceCharactersInRange:NSMakeRange([[self string] length], 0)
                        withString:[string autorelease]];
    va_end(argList);
}

- (void)appendString:(NSString *)aString
{
    [self replaceCharactersInRange:NSMakeRange([[self string] length], 0)
                        withString:(NSString *)aString];
}

- (void)appendRTF:(NSData *)rtfData
{
    [self replaceCharactersInRange:NSMakeRange([[self string] length], 0)
                           withRTF:(NSData *)rtfData];
}

- (void)appendRTFD:(NSData *)rtfdData
{
    [self replaceCharactersInRange:NSMakeRange([[self string] length], 0)
                          withRTFD:(NSData *)rtfdData];
}

@end
