#import "TCAppKitExtensions.h"

static NSPoint _TCModelessAlertPanelCascadingOrigin = { 470.0, 400.0 };

@implementation TCModelessAlertPanel

+ (TCModelessAlertPanel *)modelessAlertPanel
{
    return (TCModelessAlertPanel *)[self sharedPanelController];
}

- (id)init
{
    if (self = [super init]) {
        NSRect screenFrame = [[NSScreen mainScreen] frame];

        [iconView setImage:[[NSApplication sharedApplication] applicationIconImage]];

        _TCModelessAlertPanelCascadingOrigin.x += 20.0;
        if (_TCModelessAlertPanelCascadingOrigin.x > screenFrame.size.width)
            _TCModelessAlertPanelCascadingOrigin.x = 20.0;
        _TCModelessAlertPanelCascadingOrigin.y -= 20.0;
        if (_TCModelessAlertPanelCascadingOrigin.y < 0.0)
            _TCModelessAlertPanelCascadingOrigin.y = screenFrame.size.height + 20.0;
        
        [panel setFrameTopLeftPoint:_TCModelessAlertPanelCascadingOrigin];
    }

    return self;
}

- (BOOL)shouldSavePanelPosition
{
    return NO;
}

- (void)setTitle:(NSString *)title
{
    [titleView setStringValue:title];
}

- (NSString *)title
{
    return [titleView stringValue];
}

- (void)setAlertMessage:(NSString *)title
{
    [textView setStringValue:title];
}

- (NSString *)alertMessage
{
    return [textView stringValue];
}

- (void)windowWillClose:(NSNotification *)aNotification
{
    [self autorelease];
}

@end

void TCShowModelessAlertPanel(NSString *windowTitle, NSString *format, ...)
{
    va_list	argList;
    NSString   *string;
    TCModelessAlertPanel *panel = [[TCModelessAlertPanel alloc] init];

    va_start(argList, format);
    string = [[[NSString alloc] initWithFormat:format arguments:argList] autorelease];

    [panel setTitle:windowTitle];
    [panel setAlertMessage:string];
    [panel orderFront];
    
    va_end(argList);
}
