#import "TCAppKitExtensions.h"

@implementation TCPanelController

+ (TCPanelController *)sharedPanelController
{
    static id _singleton = nil;

    if (_singleton == nil)
        _singleton = [[self alloc] init];

    return _singleton;
}

- (id)init
{
    if (self = [super init]) {
        if (![NSBundle loadNibNamed:[[self class] description] owner:self]) {
            TCLog(self, _cmd, TCLocalizedStringForKey(@"nibLoadingErrorFormat"), [[self class] description]);
            NSRunCriticalAlertPanel(TCLocalizedStringForKey(@"nibLoadingError"),
                                    TCLocalizedStringForKey(@"nibLoadingErrorFormat"),
                                    TCLocalizedStringForKey(@"cancel"), nil, nil,
                                    [[self class] description]);
        }

        if ([self shouldSavePanelPosition]){
            [panel setFrameAutosaveName:[[self class] description]];
            [panel setFrameUsingName:[[self class] description]];
        }
    }

    return self;
}

- (BOOL)shouldSavePanelPosition
{
    return YES;
}

- (void)orderFront
{
    [panel makeKeyAndOrderFront:nil];
}

- (void)close
{
    [panel close];
}

- (NSPanel *)panel
{
    return panel;
}

@end
