@class NSImage;
@class NSString;

@interface TCToolBar : NSView
{
    NSMutableDictionary *cellDictionary;
    NSSize cellSize;
    float intercellSpacing;
    float nextCellOriginLeft;
    NSGradientType gradientType;
    NSBorderType borderType;
}

// set/get the size of the cell (prototype)
- (NSSize)cellSize;
- (void)setCellSize:(NSSize)size;

// set/get the intercell spacing
- (float)intercellSpacing;
- (void)setIntercellSpacing:(float)width;

// set/get the toolbar border
- (NSBorderType)borderType;
- (void)setBorderType:(NSBorderType)borderType;

// set/get the gradients for the cells
- (NSGradientType)gradientType;
- (void)setGradientType:(NSGradientType)type;

// retrieving individual cells
- (NSButton *)cellNamed:(NSString *)name;
- (NSArray *)cells;

// adding cells. note that there's currently no way to remove a cell...
- (void)addCellName:(NSString *)name icon:(NSImage *)iconImage toolTip:(NSString *)toolTip preceedingSeparator:(BOOL)separatorFlag target:(id)target action:(SEL)action;

@end
