/*
 * TCNSArrayExtensions.h
 * Category of extensions to the NSArray Foundation class.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */

@interface NSArray (TCNSArrayExtensions)

/*" Array creation "*/
+ (NSArray *)arrayWithCStringArray:(char **)cStringArray;
- initWithCStringArray:(char **)cStringArray;

/*" Conversion to C types "*/
- (const char **)cStringArray;

/*" Extras "*/
- (void)makeObjectsPerformSelector:(SEL)aSelector withObject:anObject withObject:anotherObject;

@end

/*
 * NSMutableArrayExtensions.h
 * Category of extensions to NSMutableArray Foundation class.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */

@interface NSMutableArray (TCNSMutableArrayExtensions)

/*" Removing objects "*/
- (void)removeObjectsEqualTo:anObject;

@end

