/*
 * TCNSDataExtensions.h
 * Category of extensions to the NSData Foundation class.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */

@interface NSData (TCNSDataExtensions)

/*" Conveniences "*/
+ (NSData *)dataWithOutputOfTask:(NSTask *)shellTask;
+ (NSData *)dataWithOutputOfTask:(NSTask *)shellTask inputData:(NSData *)stdinData;
+ (NSData *)dataWithOutputOfTask:(NSTask *)shellTask inputString:(NSString *)stdinString;

/*" Data creation "*/
- (id)initWithOutputOfTask:(NSTask *)shellTask;
- (id)initWithOutputOfTask:(NSTask *)shellTask inputData:(NSData *)stdinData;
- (id)initWithOutputOfTask:(NSTask *)shellTask inputString:(NSString *)stdinString;

@end
