/* NSPort+TCExtensions.m created by dwy on Sun 04-Jan-1998 */

#import <Foundation/Foundation.h>
#import "NSPort+TCExtensions.h"

@implementation NSPort(TCExtensions)

- (BOOL)sendData:(NSData *)data beforeDate:(NSDate *)limitDate
{
    NSPortMessage *message;
    NSArray *components = [NSArray arrayWithObject:data];

    message = [[[NSPortMessage alloc] initWithSendPort:self
                                           receivePort:nil
                                            components:components] autorelease];

    return [message sendBeforeDate:limitDate];
}

- (BOOL)sendData:(NSData *)data
{
    return [self sendData:data beforeDate:[NSDate distantFuture]];
}

- (BOOL)sendObject:(id <NSCoding>)anObject
{
    return [self sendData:[NSArchiver archivedDataWithRootObject:anObject]];
}

@end
