/* NSString+TCExtensions.h created by dwy on Sat 03-Jan-1998 */

@class NSString, NSData;

@interface NSString(TCExtensions)

+ (NSString *)stringWithData:(NSData *)data encoding:(NSStringEncoding)encoding;
+ (NSString *)stringWithContentsOfFile:(NSString *)fileName;
+ (NSString *)stringWithTemporaryFileName;

- (NSString *)stringByExpandingPathInHomeDirectory;
- (NSString *)stringByExpandingPathInLibraryDirectory;

/*" Prefices and suffices "*/
- (NSString *)stringByPrependingString:(NSString *)aString;
- (NSString* )stringByRemovingPrefix:(NSString *)aPrefix;
- (NSString* )stringByRemovingSuffix:(NSString *)aSuffix;

/* Misc. fun */
- (BOOL)matchesWildcard:(NSString *)wildcard;

/*" Selectors "*/
+ (NSString *)stringWithSelector:(SEL)aSel;
- (SEL)selectorValue;

- (NSString *)stringByPaddingToByteBoundary:(unsigned)boundary
        padCharacter:(NSString *)padChar;
- (NSArray *)componentsBrokenIntoPartsOfLength:(unsigned)length;

- (id)initWithTemporaryFileName;

- (NSString *)stringByRemovingTrailingNulls;

+ (NSString *)stringWithHexBytesInData:(NSData *)data;
- (NSData *)dataUsingHexEncoding;

@end

@interface NSMutableString (TCNSMutableStringExtensions)

- (void)appendCString:(char *)cString;
- (void)appendWithFormat:(NSString *)format, ...;

@end
