#import "TCFoundationExtensions.h"

DEFINE_NSSTRING(TCUNIXErrorCodeItemKey);

DEFINE_NSSTRING(TCOperationNotPermittedException);	// EPERM (1)
DEFINE_NSSTRING(TCNoSuchFileOrDirectoryException);	// ENOENT (2)
DEFINE_NSSTRING(TCNoSuchProcessException);	// ESRCH (3)
DEFINE_NSSTRING(TCInterruptedSystemCallException);	// EINTR (4)
DEFINE_NSSTRING(TCInputOutputErrorException);	// EIO (5)
DEFINE_NSSTRING(TCDeviceNotConfiguredException);	// ENXIO (6)
DEFINE_NSSTRING(TCArgumentListTooLongException);	// E2BIG (7)
DEFINE_NSSTRING(TCExecFormatErrorException);	// ENOEXEC (8)
DEFINE_NSSTRING(TCBadFileDescriptorException);	// EBADF (9)
DEFINE_NSSTRING(TCNoChildProcessesException);	// ECHILD (10)
DEFINE_NSSTRING(TCResourceDeadlockAvoidedException);	// EDEADLK (11)
DEFINE_NSSTRING(TCCannotAllocateMemoryException);	// ENOMEM (12)
DEFINE_NSSTRING(TCPermissionDeniedException);	// EACCES (13)
DEFINE_NSSTRING(TCBadAddressException);	// EFAULT (14)
DEFINE_NSSTRING(TCBlockDeviceRequiredException);	// ENOTBLK (15)
DEFINE_NSSTRING(TCDeviceBusyException);	// EBUSY (16)
DEFINE_NSSTRING(TCFileExistsException);	// EEXIST (17)
DEFINE_NSSTRING(TCCrossDeviceLinkException);	// EXDEV (18)
DEFINE_NSSTRING(TCOperationNotSupportedByDeviceException);	// ENODEV (19)
DEFINE_NSSTRING(TCNotADirectoryException);	// ENOTDIR (20)
DEFINE_NSSTRING(TCIsADirectoryException);	// EISDIR (21)
DEFINE_NSSTRING(TCInvalidArgumentException);	// EINVAL (22)
DEFINE_NSSTRING(TCTooManyOpenFilesInSystemException);	// ENFILE (23)
DEFINE_NSSTRING(TCTooManyOpenFilesException);	// EMFILE (24)
DEFINE_NSSTRING(TCInappropriateIoctlForDeviceException);	// ENOTTY (25)
DEFINE_NSSTRING(TCTextFileBusyException);	// ETXTBSY (26)
DEFINE_NSSTRING(TCFileTooLargeException);	// EFBIG (27)
DEFINE_NSSTRING(TCNoSpaceLeftOnDeviceException);	// ENOSPC (28)
DEFINE_NSSTRING(TCIllegalSeekException);	// ESPIPE (29)
DEFINE_NSSTRING(TCReadOnlyFileSystemException);	// EROFS (30)
DEFINE_NSSTRING(TCTooManyLinksException);	// EMLINK (31)
DEFINE_NSSTRING(TCBrokenPipeException);	// EPIPE (32)
DEFINE_NSSTRING(TCNumericalArgumentOutOfDomainException);	// EDOM (33)
DEFINE_NSSTRING(TCResultTooLargeException);	// ERANGE (34)
DEFINE_NSSTRING(TCResourceTemporarilyUnavailableException);	// EAGAIN (35)
DEFINE_NSSTRING(TCOperationWouldBlockException);	// EWOULDBLOCK (EAGAIN)
DEFINE_NSSTRING(TCOperationNowInProgressException);	// EINPROGRESS (36)
DEFINE_NSSTRING(TCOperationAlreadyInProgressException);	// EALREADY (37)
DEFINE_NSSTRING(TCSocketOperationOnNonSocketException);	// ENOTSOCK (38)
DEFINE_NSSTRING(TCDestinationAddressRequiredException);	// EDESTADDRREQ (39)
DEFINE_NSSTRING(TCMessageTooLongException);	// EMSGSIZE (40)
DEFINE_NSSTRING(TCProtocolWrongTypeForSocketException);	// EPROTOTYPE (41)
DEFINE_NSSTRING(TCProtocolNotAvailableException);	// ENOPROTOOPT (42)
DEFINE_NSSTRING(TCProtocolNotSupportedException);	// EPROTONOSUPPORT (43)
DEFINE_NSSTRING(TCSocketTypeNotSupportedException);	// ESOCKTNOSUPPORT (44)
DEFINE_NSSTRING(TCOperationNotSupportedException);	// EOPNOTSUPP (45)
DEFINE_NSSTRING(TCProtocolFamilyNotSupportedException);	// EPFNOSUPPORT (46)
DEFINE_NSSTRING(TCAddressFamilyNotSupportedByProtocolFamilyException);	// EAFNOSUPPORT (47)
DEFINE_NSSTRING(TCAddressAlreadyInUseException);	// EADDRINUSE (48)
DEFINE_NSSTRING(TCCanTAssignRequestedAddressException);	// EADDRNOTAVAIL (49)
DEFINE_NSSTRING(TCNetworkIsDownException);	// ENETDOWN (50)
DEFINE_NSSTRING(TCNetworkIsUnreachableException);	// ENETUNREACH (51)
DEFINE_NSSTRING(TCNetworkDroppedConnectionOnResetException);	// ENETRESET (52)
DEFINE_NSSTRING(TCSoftwareCausedConnectionAbortException);	// ECONNABORTED (53)
DEFINE_NSSTRING(TCConnectionResetByPeerException);	// ECONNRESET (54)
DEFINE_NSSTRING(TCNoBufferSpaceAvailableException);	// ENOBUFS (55)
DEFINE_NSSTRING(TCSocketIsAlreadyConnectedException);	// EISCONN (56)
DEFINE_NSSTRING(TCSocketIsNotConnectedException);	// ENOTCONN (57)
DEFINE_NSSTRING(TCCanTSendAfterSocketShutdownException);	// ESHUTDOWN (58)
DEFINE_NSSTRING(TCTooManyReferencesCanTSpliceException);	// ETOOMANYREFS (59)
DEFINE_NSSTRING(TCOperationTimedOutException);	// ETIMEDOUT (60)
DEFINE_NSSTRING(TCConnectionRefusedException);	// ECONNREFUSED (61)
DEFINE_NSSTRING(TCTooManyLevelsOfSymbolicLinksException);	// ELOOP (62)
DEFINE_NSSTRING(TCFileNameTooLongException);	// ENAMETOOLONG (63)
DEFINE_NSSTRING(TCHostIsDownException);	// EHOSTDOWN (64)
DEFINE_NSSTRING(TCNoRouteToHostException);	// EHOSTUNREACH (65)
DEFINE_NSSTRING(TCDirectoryNotEmptyException);	// ENOTEMPTY (66)
DEFINE_NSSTRING(TCTooManyProcessesException);	// EPROCLIM (67)
DEFINE_NSSTRING(TCTooManyUsersException);	// EUSERS (68)
DEFINE_NSSTRING(TCDiscQuotaExceededException);	// EDQUOT (69)
DEFINE_NSSTRING(TCStaleNFSFileHandleException);	// ESTALE (70)
DEFINE_NSSTRING(TCTooManyLevelsOfRemoteInPathException);	// EREMOTE (71)
DEFINE_NSSTRING(TCRPCStructIsBadException);	// EBADRPC (72)
DEFINE_NSSTRING(TCRPCVersionWrongException);	// ERPCMISMATCH (73)
DEFINE_NSSTRING(TCRPCProgNotAvailException);	// EPROGUNAVAIL (74)
DEFINE_NSSTRING(TCProgramVersionWrongException);	// EPROGMISMATCH (75)
DEFINE_NSSTRING(TCBadProcedureForProgramException);	// EPROCUNAVAIL (76)
DEFINE_NSSTRING(TCNoLocksAvailableException);	// ENOLCK (77)
DEFINE_NSSTRING(TCFunctionNotImplementedException);	// ENOSYS (78)
DEFINE_NSSTRING(TCInappropriateFileTypeOrFormatException);	// EFTYPE (79)
DEFINE_NSSTRING(TCAuthenticationErrorException);	// EAUTH (80)
DEFINE_NSSTRING(TCNeedAuthenticatorException);	// ENEEDAUTH (81)
DEFINE_NSSTRING(TCMustBeEqualLargestErrnoException);	// ELAST (81)
DEFINE_NSSTRING(TCDevicePowerIsOffException);	// EPWROFF (82)
DEFINE_NSSTRING(TCDeviceErrorEGPaperOutException);	// EDEVERR (83)
DEFINE_NSSTRING(TCDeviceNotInitializedException);	// ENOINIT (84)
DEFINE_NSSTRING(TCBadExecutableException);	// EBADEXEC (85)
DEFINE_NSSTRING(TCBadCPUTypeInExecutableException);	// EBADARCH (86)
DEFINE_NSSTRING(TCSharedLibraryVersionMismatchException);	// ESHLIBVERS (87)
DEFINE_NSSTRING(TCMalformedMachOFileException);	// EBADMACHO (88)

DEFINE_NSSTRING(TCRestartSystemCallException);	// ERESTART (-1)
DEFINE_NSSTRING(TCDontModifyRegsJustReturnException);	// EJUSTRETURN (-2)

struct _unixLevelExceptionEntry {
    NSString *name;
    NSString *reason;
};

static struct _unixLevelExceptionEntry _exceptionTable[89];
static BOOL _tableInitialized = NO;

static void _TCInitializeTableEntries(void)
{
    _exceptionTable[1].name = TCOperationNotPermittedException;	// EPERM (1)
    _exceptionTable[1].reason = @"Operation not permitted";
    _exceptionTable[2].name = TCNoSuchFileOrDirectoryException;	// ENOENT (2)
    _exceptionTable[2].reason = @"No such file or directory";
    _exceptionTable[3].name = TCNoSuchProcessException;	// ESRCH (3)
    _exceptionTable[3].reason = @"No such process";
    _exceptionTable[4].name = TCInterruptedSystemCallException;	// EINTR (4)
    _exceptionTable[4].reason = @"Interrupted system call";
    _exceptionTable[5].name = TCInputOutputErrorException;	// EIO (5)
    _exceptionTable[5].reason = @"Input/output error";
    _exceptionTable[6].name = TCDeviceNotConfiguredException;	// ENXIO (6)
    _exceptionTable[6].reason = @"Device not configured";
    _exceptionTable[7].name = TCArgumentListTooLongException;	// E2BIG (7)
    _exceptionTable[7].reason = @"Argument list too long";
    _exceptionTable[8].name = TCExecFormatErrorException;	// ENOEXEC (8)
    _exceptionTable[8].reason = @"Exec format error";
    _exceptionTable[9].name = TCBadFileDescriptorException;	// EBADF (9)
    _exceptionTable[9].reason = @"Bad file descriptor";
    _exceptionTable[10].name = TCNoChildProcessesException;	// ECHILD (10)
    _exceptionTable[10].reason = @"No child processes";
    _exceptionTable[11].name = TCResourceDeadlockAvoidedException;	// EDEADLK (11)
    _exceptionTable[11].reason = @"Resource deadlock avoided";
    _exceptionTable[12].name = TCCannotAllocateMemoryException;	// ENOMEM (12)
    _exceptionTable[12].reason = @"Cannot allocate memory";
    _exceptionTable[13].name = TCPermissionDeniedException;	// EACCES (13)
    _exceptionTable[13].reason = @"Permission denied";
    _exceptionTable[14].name = TCBadAddressException;	// EFAULT (14)
    _exceptionTable[14].reason = @"Bad address";
    _exceptionTable[15].name = TCBlockDeviceRequiredException;	// ENOTBLK (15)
    _exceptionTable[15].reason = @"Block device required";
    _exceptionTable[16].name = TCDeviceBusyException;	// EBUSY (16)
    _exceptionTable[16].reason = @"Device busy";
    _exceptionTable[17].name = TCFileExistsException;	// EEXIST (17)
    _exceptionTable[17].reason = @"File exists";
    _exceptionTable[18].name = TCCrossDeviceLinkException;	// EXDEV (18)
    _exceptionTable[18].reason = @"Cross-device link";
    _exceptionTable[19].name = TCOperationNotSupportedByDeviceException;	// ENODEV (19)
    _exceptionTable[19].reason = @"Operation not supported by device";
    _exceptionTable[20].name = TCNotADirectoryException;	// ENOTDIR (20)
    _exceptionTable[20].reason = @"Not a directory";
    _exceptionTable[21].name = TCIsADirectoryException;	// EISDIR (21)
    _exceptionTable[21].reason = @"Is a directory";
    _exceptionTable[22].name = TCInvalidArgumentException;	// EINVAL (22)
    _exceptionTable[22].reason = @"Invalid argument";
    _exceptionTable[23].name = TCTooManyOpenFilesInSystemException;	// ENFILE (23)
    _exceptionTable[23].reason = @"Too many open files in system";
    _exceptionTable[24].name = TCTooManyOpenFilesException;	// EMFILE (24)
    _exceptionTable[24].reason = @"Too many open files";
    _exceptionTable[25].name = TCInappropriateIoctlForDeviceException;	// ENOTTY (25)
    _exceptionTable[25].reason = @"Inappropriate ioctl for device";
    _exceptionTable[26].name = TCTextFileBusyException;	// ETXTBSY (26)
    _exceptionTable[26].reason = @"Text file busy";
    _exceptionTable[27].name = TCFileTooLargeException;	// EFBIG (27)
    _exceptionTable[27].reason = @"File too large";
    _exceptionTable[28].name = TCNoSpaceLeftOnDeviceException;	// ENOSPC (28)
    _exceptionTable[28].reason = @"No space left on device";
    _exceptionTable[29].name = TCIllegalSeekException;	// ESPIPE (29)
    _exceptionTable[29].reason = @"Illegal seek";
    _exceptionTable[30].name = TCReadOnlyFileSystemException;	// EROFS (30)
    _exceptionTable[30].reason = @"Read-only file system";
    _exceptionTable[31].name = TCTooManyLinksException;	// EMLINK (31)
    _exceptionTable[31].reason = @"Too many links";
    _exceptionTable[32].name = TCBrokenPipeException;	// EPIPE (32)
    _exceptionTable[32].reason = @"Broken pipe";
    _exceptionTable[33].name = TCNumericalArgumentOutOfDomainException;	// EDOM (33)
    _exceptionTable[33].reason = @"Numerical argument out of domain";
    _exceptionTable[34].name = TCResultTooLargeException;	// ERANGE (34)
    _exceptionTable[34].reason = @"Result too large";
    _exceptionTable[35].name = TCResourceTemporarilyUnavailableException;	// EAGAIN (35)
    _exceptionTable[35].reason = @"Resource temporarily unavailable";
    _exceptionTable[EAGAIN].name = TCOperationWouldBlockException;	// EWOULDBLOCK (EAGAIN)
    _exceptionTable[EAGAIN].reason = @"Operation would block";
    _exceptionTable[36].name = TCOperationNowInProgressException;	// EINPROGRESS (36)
    _exceptionTable[36].reason = @"Operation now in progress";
    _exceptionTable[37].name = TCOperationAlreadyInProgressException;	// EALREADY (37)
    _exceptionTable[37].reason = @"Operation already in progress";
    _exceptionTable[38].name = TCSocketOperationOnNonSocketException;	// ENOTSOCK (38)
    _exceptionTable[38].reason = @"Socket operation on non-socket";
    _exceptionTable[39].name = TCDestinationAddressRequiredException;	// EDESTADDRREQ (39)
    _exceptionTable[39].reason = @"Destination address required";
    _exceptionTable[40].name = TCMessageTooLongException;	// EMSGSIZE (40)
    _exceptionTable[40].reason = @"Message too long";
    _exceptionTable[41].name = TCProtocolWrongTypeForSocketException;	// EPROTOTYPE (41)
    _exceptionTable[41].reason = @"Protocol wrong type for socket";
    _exceptionTable[42].name = TCProtocolNotAvailableException;	// ENOPROTOOPT (42)
    _exceptionTable[42].reason = @"Protocol not available";
    _exceptionTable[43].name = TCProtocolNotSupportedException;	// EPROTONOSUPPORT (43)
    _exceptionTable[43].reason = @"Protocol not supported";
    _exceptionTable[44].name = TCSocketTypeNotSupportedException;	// ESOCKTNOSUPPORT (44)
    _exceptionTable[44].reason = @"Socket type not supported";
    _exceptionTable[45].name = TCOperationNotSupportedException;	// EOPNOTSUPP (45)
    _exceptionTable[45].reason = @"Operation not supported";
    _exceptionTable[46].name = TCProtocolFamilyNotSupportedException;	// EPFNOSUPPORT (46)
    _exceptionTable[46].reason = @"Protocol family not supported";
    _exceptionTable[47].name = TCAddressFamilyNotSupportedByProtocolFamilyException;	// EAFNOSUPPORT (47)
    _exceptionTable[47].reason = @"Address family not supported by protocol family";
    _exceptionTable[48].name = TCAddressAlreadyInUseException;	// EADDRINUSE (48)
    _exceptionTable[48].reason = @"Address already in use";
    _exceptionTable[49].name = TCCanTAssignRequestedAddressException;	// EADDRNOTAVAIL (49)
    _exceptionTable[49].reason = @"Can't assign requested address";
    _exceptionTable[50].name = TCNetworkIsDownException;	// ENETDOWN (50)
    _exceptionTable[50].reason = @"Network is down";
    _exceptionTable[51].name = TCNetworkIsUnreachableException;	// ENETUNREACH (51)
    _exceptionTable[51].reason = @"Network is unreachable";
    _exceptionTable[52].name = TCNetworkDroppedConnectionOnResetException;	// ENETRESET (52)
    _exceptionTable[52].reason = @"Network dropped connection on reset";
    _exceptionTable[53].name = TCSoftwareCausedConnectionAbortException;	// ECONNABORTED (53)
    _exceptionTable[53].reason = @"Software caused connection abort";
    _exceptionTable[54].name = TCConnectionResetByPeerException;	// ECONNRESET (54)
    _exceptionTable[54].reason = @"Connection reset by peer";
    _exceptionTable[55].name = TCNoBufferSpaceAvailableException;	// ENOBUFS (55)
    _exceptionTable[55].reason = @"No buffer space available";
    _exceptionTable[56].name = TCSocketIsAlreadyConnectedException;	// EISCONN (56)
    _exceptionTable[56].reason = @"Socket is already connected";
    _exceptionTable[57].name = TCSocketIsNotConnectedException;	// ENOTCONN (57)
    _exceptionTable[57].reason = @"Socket is not connected";
    _exceptionTable[58].name = TCCanTSendAfterSocketShutdownException;	// ESHUTDOWN (58)
    _exceptionTable[58].reason = @"Can't send after socket shutdown";
    _exceptionTable[59].name = TCTooManyReferencesCanTSpliceException;	// ETOOMANYREFS (59)
    _exceptionTable[59].reason = @"Too many references: can't splice";
    _exceptionTable[60].name = TCOperationTimedOutException;	// ETIMEDOUT (60)
    _exceptionTable[60].reason = @"Operation timed out";
    _exceptionTable[61].name = TCConnectionRefusedException;	// ECONNREFUSED (61)
    _exceptionTable[61].reason = @"Connection refused";
    _exceptionTable[62].name = TCTooManyLevelsOfSymbolicLinksException;	// ELOOP (62)
    _exceptionTable[62].reason = @"Too many levels of symbolic links";
    _exceptionTable[63].name = TCFileNameTooLongException;	// ENAMETOOLONG (63)
    _exceptionTable[63].reason = @"File name too long";
    _exceptionTable[64].name = TCHostIsDownException;	// EHOSTDOWN (64)
    _exceptionTable[64].reason = @"Host is down";
    _exceptionTable[65].name = TCNoRouteToHostException;	// EHOSTUNREACH (65)
    _exceptionTable[65].reason = @"No route to host";
    _exceptionTable[66].name = TCDirectoryNotEmptyException;	// ENOTEMPTY (66)
    _exceptionTable[66].reason = @"Directory not empty";
    _exceptionTable[67].name = TCTooManyProcessesException;	// EPROCLIM (67)
    _exceptionTable[67].reason = @"Too many processes";
    _exceptionTable[68].name = TCTooManyUsersException;	// EUSERS (68)
    _exceptionTable[68].reason = @"Too many users";
    _exceptionTable[69].name = TCDiscQuotaExceededException;	// EDQUOT (69)
    _exceptionTable[69].reason = @"Disc quota exceeded";
    _exceptionTable[70].name = TCStaleNFSFileHandleException;	// ESTALE (70)
    _exceptionTable[70].reason = @"Stale NFS file handle";
    _exceptionTable[71].name = TCTooManyLevelsOfRemoteInPathException;	// EREMOTE (71)
    _exceptionTable[71].reason = @"Too many levels of remote in path";
    _exceptionTable[72].name = TCRPCStructIsBadException;	// EBADRPC (72)
    _exceptionTable[72].reason = @"RPC struct is bad";
    _exceptionTable[73].name = TCRPCVersionWrongException;	// ERPCMISMATCH (73)
    _exceptionTable[73].reason = @"RPC version wrong";
    _exceptionTable[74].name = TCRPCProgNotAvailException;	// EPROGUNAVAIL (74)
    _exceptionTable[74].reason = @"RPC prog. not avail";
    _exceptionTable[75].name = TCProgramVersionWrongException;	// EPROGMISMATCH (75)
    _exceptionTable[75].reason = @"Program version wrong";
    _exceptionTable[76].name = TCBadProcedureForProgramException;	// EPROCUNAVAIL (76)
    _exceptionTable[76].reason = @"Bad procedure for program";
    _exceptionTable[77].name = TCNoLocksAvailableException;	// ENOLCK (77)
    _exceptionTable[77].reason = @"No locks available";
    _exceptionTable[78].name = TCFunctionNotImplementedException;	// ENOSYS (78)
    _exceptionTable[78].reason = @"Function not implemented";
    _exceptionTable[79].name = TCInappropriateFileTypeOrFormatException;	// EFTYPE (79)
    _exceptionTable[79].reason = @"Inappropriate file type or format";
    _exceptionTable[80].name = TCAuthenticationErrorException;	// EAUTH (80)
    _exceptionTable[80].reason = @"Authentication error";
    _exceptionTable[81].name = TCNeedAuthenticatorException;	// ENEEDAUTH (81)
    _exceptionTable[81].reason = @"Need authenticator";
    _exceptionTable[81].name = TCMustBeEqualLargestErrnoException;	// ELAST (81)
    _exceptionTable[81].reason = @"Must be equal largest errno";
    _exceptionTable[82].name = TCDevicePowerIsOffException;	// EPWROFF (82)
    _exceptionTable[82].reason = @"Device power is off";
    _exceptionTable[83].name = TCDeviceErrorEGPaperOutException;	// EDEVERR (83)
    _exceptionTable[83].reason = @"Device error, e.g. paper out";
    _exceptionTable[84].name = TCDeviceNotInitializedException;	// ENOINIT (84)
    _exceptionTable[84].reason = @"Device not initialized";
    _exceptionTable[85].name = TCBadExecutableException;	// EBADEXEC (85)
    _exceptionTable[85].reason = @"Bad executable";
    _exceptionTable[86].name = TCBadCPUTypeInExecutableException;	// EBADARCH (86)
    _exceptionTable[86].reason = @"Bad CPU type in executable";
    _exceptionTable[87].name = TCSharedLibraryVersionMismatchException;	// ESHLIBVERS (87)
    _exceptionTable[87].reason = @"Shared library version mismatch";
    _exceptionTable[88].name = TCMalformedMachOFileException;	// EBADMACHO (88)
    _exceptionTable[88].reason = @"Malformed Mach-O file";
    
    _exceptionTable[999].name = TCRestartSystemCallException;	// ERESTART (-1)
    _exceptionTable[999].reason = @"restart syscall";
    _exceptionTable[998].name = TCDontModifyRegsJustReturnException;	// EJUSTRETURN (-2)
    _exceptionTable[998].reason = @"don't modify regs, just return";
}

volatile void TCRaiseExceptionWithUNIXErrorCode(int errorCode)
{
    NSMutableDictionary *userInfo = [NSMutableDictionary dictionaryWithObjectsAndKeys:
        [NSNumber numberWithInt:errorCode], TCUNIXErrorCodeItemKey,
        nil];

    // table ready?
    if (!_tableInitialized) {
        _TCInitializeTableEntries();
        _tableInitialized = YES;
    }
    
    // can't have negative array indices now, can we...
    if (errorCode < 0)
        errorCode += 1000;

    // now raise the exception...
    [[NSException exceptionWithName:_exceptionTable[errorCode].name
                             reason:_exceptionTable[errorCode].reason
                           userInfo:userInfo] raise];
}
