/*
 * TCOperation.h
 * Private class used to model an asynchronous operation.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */

@class NSHost;

@interface TCOperation : NSObject <NSCoding>
{
    @private
    id _object;
    id _target;
    SEL _selector;
    NSDictionary *_userInfo;
}

+ (TCOperation *)operationWithObject:(id)object target:(id)target selector:(SEL)selector;
+ (TCOperation *)operationWithObject:(id)object target:(id)target selector:(SEL)selector
                            userInfo:(NSDictionary *)userInfo;

- (id)initWithObject:(id)object target:(id)target selector:(SEL)selector userInfo:(NSDictionary *)userInfo;

- (id)object;
- (id)target;
- (SEL)selector;

- (NSDictionary *)userInfo;

@end
