/*
 * TCSocket.h
 * Abstract superclass for socket objects.
 *
 * Copyright (c) 1997 21st Century Software, New York City.
 *
 * See the file Reference/License.rtf for information on usage and
 * redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 *
 * Written by David Young <dwy@ace.net>, 1997.
 */

#import "TCStream.h"

@class NSString, NSHost;

@interface TCSocket : TCStream <NSCoding>
{
    @private
    NSHost	*_localAddress, *_remoteAddress;
    unsigned	 _localPort, _remotePort;
}

/* Designated initializer, subclasses should override */
- (id)initWithLocalAddress:(NSHost *)localAddress localPort:(unsigned)localPort remoteAddress:(NSHost *)remoteAddress remotePort:(unsigned)remotePort descriptor:(int)descriptor;

/* Accessors */
- (NSHost *)remoteAddress;
- (unsigned)remotePort;

- (NSHost *)localAddress;
- (unsigned)localPort;

@end
