@class NSString, NSArray, NSPort;
@class TCStreamMonitor;

TCNETWORKING_EXPORT NSString *TCSocketAcceptorCompletionNotification;

TCNETWORKING_EXPORT NSString *TCSocketAcceptorUserInfoExceptionNameItemKey;
TCNETWORKING_EXPORT NSString *TCSocketAcceptorUserInfoExceptionReasonItemKey;

TCNETWORKING_EXPORT NSString *TCSocketAcceptorSocketArrayItemKey;

@interface TCSocketAcceptor : NSObject
{
    @private
    NSArray *_portsForListening;
    NSMutableArray *_descriptors;
    unsigned _listenQueueLength;
    NSPort *_dataPort;
}

// create an acceptor which will listen on the ports in ports(array of NSNumbers: unsigned ints)
+ (TCSocketAcceptor *)acceptorWithPorts:(NSArray *)ports;

// designated initializer
- (id)initWithPorts:(NSArray *)ports;

// accept a connection: blocking operation
- (NSArray *)acceptConnections;

// accept a connection and notify when one is available
- (void)acceptConnectionsInBackgroundAndNotify;

// dealing with queues - default queue  length is 8 connections
- (unsigned)queueLength;
- (void)setQueueLength:(unsigned)length;

@end
